package apis

import (
	"fmt"

	"github.com/gin-gonic/gin"
	"github.com/gin-gonic/gin/binding"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineDirection struct {
	api.Api
}

// GetPage 获取预估方向管理列表
// @Summary 获取预估方向管理列表
// @Description 获取预估方向管理列表
// @Tags 预估方向管理
// @Param symbol query string false "交易对"
// @Param type query int64 false "交易对类型:1=现货,2=合约"
// @Param direction query string false "预估方向"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineDirection}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-direction [get]
// @Security Bearer
func (e LineDirection) GetPage(c *gin.Context) {
	req := dto.LineDirectionGetPageReq{}
	s := service.LineDirection{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineDirection, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取预估方向管理失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取预估方向管理
// @Summary 获取预估方向管理
// @Description 获取预估方向管理
// @Tags 预估方向管理
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineDirection} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-direction/{id} [get]
// @Security Bearer
func (e LineDirection) Get(c *gin.Context) {
	req := dto.LineDirectionGetReq{}
	s := service.LineDirection{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineDirection

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取预估方向管理失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Get 获取预估方向管理
// @Summary 获取预估方向管理
// @Description 获取预估方向管理
// @Tags 预估方向管理
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineDirection} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-direction/{id} [get]
// @Security Bearer
func (e LineDirection) GetBySymbol(c *gin.Context) {
	req := dto.LineDirectionGetReq{}
	s := service.LineDirection{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	if req.Symbol == "" || req.SymbolType == 0 {
		e.Error(500, nil, "参数缺失")
		return
	}

	var object models.LineDirection

	p := actions.GetPermissionFromContext(c)
	err = s.GetBySymbol(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取预估方向管理失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Insert 创建预估方向管理
// @Summary 创建预估方向管理
// @Description 创建预估方向管理
// @Tags 预估方向管理
// @Accept application/json
// @Product application/json
// @Param data body dto.LineDirectionInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-direction [post]
// @Security Bearer
func (e LineDirection) Insert(c *gin.Context) {
	req := dto.LineDirectionInsertReq{}
	s := service.LineDirection{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建预估方向管理失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改预估方向管理
// @Summary 修改预估方向管理
// @Description 修改预估方向管理
// @Tags 预估方向管理
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineDirectionUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-direction/{id} [put]
// @Security Bearer
func (e LineDirection) Update(c *gin.Context) {
	req := dto.LineDirectionUpdateReq{}
	s := service.LineDirection{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改预估方向管理失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "修改成功")
}

// Delete 删除预估方向管理
// @Summary 删除预估方向管理
// @Description 删除预估方向管理
// @Tags 预估方向管理
// @Param data body dto.LineDirectionDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-direction [delete]
// @Security Bearer
func (e LineDirection) Delete(c *gin.Context) {
	s := service.LineDirection{}
	req := dto.LineDirectionDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除预估方向管理失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "删除成功")
}

// AddDirection 新增预估方向
func (e LineDirection) AddDirection(c *gin.Context) {
	s := service.LineDirection{}
	req := dto.AddDirectionReq{}

	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req, binding.Form).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	err = s.AddDirection(req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("生成预估方向失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(nil, "操作成功")
}

// 重新统计分组信息
func (e LineDirection) ReloadGroupData(c *gin.Context) {
	s := service.LineDirection{}

	err := e.MakeContext(c).
		MakeOrm().
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	if err := s.ReloadGroup(); err != nil {
		e.Error(500, err, fmt.Sprintf("重新统计分组信息失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(nil, "操作成功")
}
